(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***  DIFFIT (formerly CreateDif) to create difference/patch files and then ***
 ***  apply them to a target. It is especially for binary files.            ***
 ***                                                                        ***
 ***  Version [1.10]                                {Last mod 2003-09-20}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***      Translation/optimization: Copyright (c) 2003 by -=Assarbad=-      ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad @ gmx.info|.net|.com|.de  |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 NOTE: This source is dual-licensed. You may choose between the BSD-License as
       seen below or the LGPL as can be found at http://www.opensource.org
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 ******************************************************************************)

program diffit;
{$APPTYPE CONSOLE}

uses
  Windows,
  MD5;

{$INCLUDE .\Include\FormatString.pas}

function _CreateDif(inpf1, inpf2, inpf3: string): Boolean;
var
  f1, f2: THandle;
  m1, m2: THandle;
  p1, p2: PChar;
  s1: DWORD;
  i: DWORD;
  f3: Textfile;
begin
  result := False;
  if ((inpf1 = '') or (inpf2 = '') or (inpf3 = '')) then
    Exit;
  AssignFile(f3, inpf3);
  ReWrite(f3);
  Writeln('#INPUT :  ', MD5_Hash2String(MD5_HashForFileA(@inpf1[1])));
  Writeln('#OUTPUT:  ', MD5_Hash2String(MD5_HashForFileA(@inpf2[1])));
  Writeln(f3, inpf1);
  Writeln(f3, '#INPUT :  ', MD5_Hash2String(MD5_HashForFileA(@inpf1[1])));
  Writeln(f3, '#OUTPUT:  ', MD5_Hash2String(MD5_HashForFileA(@inpf2[1])));
  f1 := CreateFile(@inpf1[1], GENERIC_READ, 0, nil, OPEN_EXISTING, 0, 0);
  if f1 <> INVALID_HANDLE_VALUE then
  try
    f2 := CreateFile(@inpf2[1], GENERIC_READ, 0, nil, OPEN_EXISTING, 0, 0);
    if f2 <> INVALID_HANDLE_VALUE then
    try
      s1 := GetFileSize(f1, nil);
      if s1 = GetFileSize(f2, nil) then
      begin
        m1 := CreateFileMapping(f1, nil, PAGE_READONLY, 0, s1, nil);
        if m1 <> 0 then
        try
          m2 := CreateFileMapping(f2, nil, PAGE_READONLY, 0, s1, nil);
          if m2 <> 0 then
          try
          finally
            p1 := MapViewOfFile(m1, FILE_MAP_READ, 0, 0, s1);
            if p1 <> nil then
            try
              p2 := MapViewOfFile(m2, FILE_MAP_READ, 0, 0, s1);
              if p2 <> nil then
              try
                for i := 0 to s1 - 1 do
                  if p1[i] <> p2[i] then
                  begin
                    Writeln(f3, Format('%8.8X: %2.2X %2.2X', [i, ord(p1[i]), ord(p2[i])]));
                    Writeln(Format('%8.8X: %2.2X %2.2X', [i, ord(p1[i]), ord(p2[i])]));
                  end;
                result := True;
              finally
                UnMapViewOfFile(p2);
              end
              else
                Writeln('Could not map the view of file: ', inpf2);
            finally
              UnMapViewOfFile(p1);
            end
            else
              Writeln('Could not map the view of file: ', inpf1);
          end
          else
            Writeln('Could not map the file: ', inpf2);
        finally
          CloseHandle(m1);
        end
        else
          Writeln('Could not map the file: ', inpf1);
      end
      else
        Writeln('File sizes do not match!!!');
    finally
      CloseHandle(f2);
    end
    else
      Writeln('Panic, a problem occured when trying to open the file: ', GetLastError, #13#10 + inpf2);
  finally
    CloseHandle(f1);
  end
  else
    Writeln('Panic, a problem occured when trying to open the file: ', GetLastError, #13#10 + inpf1);
  CloseFile(f3);
  Writeln;
end;

function _ApplyDif(exefile, diffile: string): Boolean;
var
  m1,
    f1: THandle;
  f2: Textfile;
  i,
    s1: DWORD;
  p1: PChar;
  err: Integer;
  x, y: Byte;
  temps: string;
begin
  result := False;
  f1 := CreateFile(@exefile[1], GENERIC_READ or GENERIC_WRITE, 0, nil, OPEN_EXISTING, 0, 0);
  if f1 <> INVALID_HANDLE_VALUE then
  try
    AssignFile(f2, diffile);
    Reset(f2);
// Read file name (this is being ignored)
    Readln(f2, temps);
// Read input file checksum
    Readln(f2, temps);
    temps := copy(temps, 11, 32);
    s1 := GetFileSize(f1, nil);
    if temps = MD5_Hash2String(MD5_Hash_OverFileByHandle(f1)) then
    begin
      Writeln('Checksum matches: ', temps);
// Read output file checksum
      Readln(f2, temps);
      m1 := CreateFileMapping(f1, nil, PAGE_READWRITE, 0, s1, nil);
      if m1 <> 0 then
      try
        p1 := MapViewOfFile(m1, FILE_MAP_READ or FILE_MAP_WRITE, 0, 0, s1);
        if p1 <> nil then
        try
          while not eof(f2) do
          begin
            Readln(f2, temps);
            if length(temps) = 15 then
            begin
              temps[10] := '$';
              temps[13] := '$';
              val('$' + copy(temps, 1, 8), i, err);
              if err = 0 then
              begin
                val(copy(temps, 13, 3), y, err);
                if err = 0 then
                begin
                  val(copy(temps, 10, 3), x, err);
                  p1[i] := Chr(y);
                  Writeln(Format('Patching @%8.8X from 0x%2.2X to 0x%2.2X', [i, x, y]));
                end
                else
                  Writeln('Error in difference file!');
              end
              else
                Writeln('Error in difference file!');
            end;
          end;
          Result := True;
        finally
          UnMapViewOfFile(p1);
        end;
      finally
        CloseHandle(m1);
      end;
    end
    else
      Writeln('Checksum doesn''t match.');
  finally
    CloseHandle(f1);
  end
  else
    Writeln('Panic, a problem occured when trying to open the file: ', GetLastError, #13#10 + exefile);
  Writeln;
end;

procedure ShowSyntax;
begin
  Writeln('Syntax:');
  Writeln('    DIFFIT /C [1st file] [2nd file] [output difference file]');
  Writeln('    DIFFIT /A [file to patch] [input difference file]');
  Writeln('    DIFFIT /?');
  Writeln('/C - creates a difference/patch file');
  Writeln('/A - applies a difference/patch file');
  Writeln;
  Writeln('The output file must not exist!!! If it exists and is writable, it is being');
  Writeln('overwritten.');
  Writeln('For the /A mode there is no check except the MD5 hash which ensures the');
  Writeln('integrity of the input file and hence of the output.');
end;

begin
  Writeln('DIFFIT (c) 2002-2003 by -=Assarbad=-');
  Writeln('Creates a difference file for two input files. Can apply a difference file.');
  Writeln;
  if length(paramstr(1)) > 1 then
    case paramstr(1)[2] of
      'C', 'c':
        if _CreateDif(paramstr(2), paramstr(3), paramstr(4)) then
          Writeln('Successfully created the difference file.')
        else
          Writeln('An error occurred. Difference file not complete.');
      'A', 'a':
        if _ApplyDif(paramstr(2), paramstr(3)) then
          Writeln('Successfully patched the difference file.')
        else
          Writeln('An error occurred. File could not be patched.');
    else //  '?','H','h':
      ShowSyntax;
    end
  else
    ShowSyntax;
end.

